var Keyconfig, Shortcuts, events,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Keyconfig = require('keyconfig');

events = require('events');

require('mousetrap');

require('mousetrap-global-bind');

module.exports = Shortcuts = (function(superClass) {
  extend(Shortcuts, superClass);

  function Shortcuts(defaults) {
    var transform;
    if (defaults == null) {
      defaults = {};
    }
    this.config = new Keyconfig(defaults);
    this.config.on('change', function(collection, model) {
      return this.emit('change', collection, model);
    });
    this._numListeners = this.config.reduce(function(acc, x) {
      acc[x.name] = 0;
      return acc;
    }, {});
    this._listeners = {};
    transform = (function(_this) {
      return function(event) {
        var collection, collectionName, eventName, ref;
        ref = event.split(':'), eventName = ref[0], collectionName = ref[1];
        if (eventName !== 'key' || !(collection = _this.get(collectionName))) {
          return void 0;
        }
        return collection;
      };
    })(this);
    this.on('newListener', (function(_this) {
      return function(event) {
        var collection;
        if (!(collection = transform(event))) {
          return void 0;
        }
        if (++_this._numListeners[collection.name] === 1) {
          return _this._bind(collection);
        }
      };
    })(this));
    this.on('removeListener', (function(_this) {
      return function(event) {
        var collection;
        if (!(collection = transform(event))) {
          return void 0;
        }
        if (--_this._numListeners[collection.name] === 0) {
          return _this._unbind(collection);
        }
      };
    })(this));
    Shortcuts.__super__.constructor.call(this);
  }

  Shortcuts.prototype.removeAllListeners = function(type) {
    if (!type) {
      throw new Error('missing type');
    }
    return Shortcuts.__super__.removeAllListeners.call(this, type);
  };

  Shortcuts._osIndex = /(Mac|iPhone|iPod|iPad)/i.test(window.navigator.platform) ? 1 : 0;

  Shortcuts.prototype._bind = function(collection) {
    var base, index, name;
    index = ((base = this._listeners)[name = collection.name] || (base[name] = {}));
    return collection.each((function(_this) {
      return function(model) {
        var bindings, cb, i, len, listeners, name1, ref, sequence;
        bindings = [].concat(model.binding[Shortcuts._osIndex]).filter(Boolean);
        if (bindings.length) {
          listeners = (index[name1 = model.name] || (index[name1] = []));
          for (i = 0, len = bindings.length; i < len; i++) {
            sequence = bindings[i];
            cb = function(e) {
              e.collection = collection;
              e.model = model;
              e.sequence = sequence;
              return _this.emit("key:" + collection.name, e);
            };
            listeners.push({
              sequence: sequence,
              cb: cb
            });
            if (((ref = model.options) != null ? ref.global : void 0) === true) {
              Mousetrap.bindGlobal(sequence, cb);
            } else {
              Mousetrap.bind(sequence, cb);
            }
          }
        }
      };
    })(this));
  };

  Shortcuts.prototype._unbind = function(collection) {
    var index, key, listener, listeners;
    index = this._listeners[collection.name];
    for (key in index) {
      listeners = index[key];
      while ((listener = listeners.pop()) != null) {
        Mousetrap.unbind(listener.sequence, listener.cb);
      }
      delete index[key];
    }
    delete this._listeners[collection.name];
  };

  Shortcuts.prototype.get = function(collectionName, modelName) {
    var collection, model;
    collection = this.config.find({
      name: collectionName
    });
    if (!modelName || (modelName && !collection)) {
      return collection;
    } else {
      model = collection.find({
        name: modelName
      });
      return model;
    }
  };

  return Shortcuts;

})(events.EventEmitter);
